#!/bin/sh

CURRENT_DIR=`pwd`
TARGET_DIR=../../distribution/

cd $TARGET_DIR

# delete old build
rm -fr *

# export from Subversion
svn export http://www2.futureware.at/svn/gregor/Moonlight/Moonlight

cd Moonlight

# build java parts of Moonlight|3D
ant compile
ant package

# build win32 startup batch file

WIN32_CLASSPATH=ml3d.jar

for i in lib/jar/*.jar ; do
  WIN32_CLASSPATH="$i;$WIN32_CLASSPATH"
done

for i in lib/Win32/i686/*.jar ; do
  WIN32_CLASSPATH="$i;$WIN32_CLASSPATH"
done

# delete bin/ directory with class files from distribution
rm -vfr bin/

# delete build-distribution.sh from actual distribution
rm build-distribution.sh

# build doxygen documentation
doxygen Doxyfile

# build platform only versions of archives:

cd ..

# build Linux/i686 archive
mkdir Moonlight-Linux-i686/
cp -vR Moonlight/* Moonlight-Linux-i686/
rm -vfr Moonlight-Linux-i686/lib/Darwin/
rm -vfr Moonlight-Linux-i686/lib/Win32/
rm -vfr Moonlight-Linux-i686/lib/Linux/x86_64/
rm -vfr Moonlight-Linux/i686/*.bat

# build Linux/x86_64 archive
mkdir Moonlight-Linux-x86_64/
cp -vR Moonlight/* Moonlight-Linux-x86_64/
rm -vfr Moonlight-Linux-x86_64/lib/Darwin/
rm -vfr Moonlight-Linux-x86_64/lib/Win32/
rm -vfr Moonlight-Linux-x86_64/lib/Linux/i686/
rm -vfr Moonlight-Linux/x86_64/*.bat

# build Win32/i686 archive
mkdir Moonlight-Win32-i686/
cp -vR Moonlight/* Moonlight-Win32-i686/
rm -vfr Moonlight-Win32-i686/lib/Darwin/
rm -vfr Moonlight-Win32-i686/lib/Linux/
rm -vfr Moonlight-Win32-i686/*.sh

# compress archives
zip -r Moonlight-Win32-i686.zip Moonlight-Win32-i686/
tar -cvjf Moonlight-Linux-i686.tar.bz2 Moonlight-Linux-i686/
tar -cvjf Moonlight-Linux-x86_64.tar.bz2 Moonlight-Linux-x86_64/

cd $CURRENT_DIR
