/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jul 17, 2006
 */
package eu.moonlight3d.ml3d.animation.basic;


import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.localization.L10N;
import eu.moonlight3d.framework.ui.Action;
import eu.moonlight3d.ml3d.backend.selection.Selection;
import eu.moonlight3d.ml3d.backend.threedim.anim.Animation;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;

public class DeleteAnimationAction extends Action {
	public DeleteAnimationAction(QWidget parent) {
		super("DeleteAnimationAction",L10N.translate("Delete animation"),parent);
		triggered.connect(this,"run()");
	}

	@Override
	public void run() throws Exception {
		// find currently selected animation and remove it
		Document document=(Document) State.getInstance().getDocumentManager().getMainDocument();
		
		Selection selection=document.getSelectionManager().getSelection("animationSelection");
		if(selection.getActiveObject()==null) {
			State.getInstance().logger().warning(L10N.translate("no animation track active"));
			return;
		}
		
		Animation animation=(Animation) selection.getObjectFromSelectionString(selection.getActiveObject());
		
		selection.clearSelection(selection.getType());
		document.getAnimationManager().removeAnimation(animation.getName());
	}

}
