/*
 * Moonlight|3D
 * Copyright (C) 2009 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Sep 12, 2009
 */

package eu.moonlight3d.ml3d.animation.basic;

import com.trolltech.qt.gui.QColor;
import com.trolltech.qt.gui.QPaintEvent;
import com.trolltech.qt.gui.QPainter;
import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.ml3d.backend.threedim.anim.Animation;

public class TrackView extends QWidget {
	private Animation currentAnimation;
	
	TrackView(QWidget parent) {
		super(parent);
		setFixedSize(1000,1000);
	}
	
	void setAnimation(Animation animation) {
		currentAnimation=animation;
		update();
	}
	
	@Override
	protected void paintEvent(QPaintEvent event) {
		if(currentAnimation==null) {
			return;
		}
		
		QPainter painter=new QPainter();
		painter.begin(this);
		
		int numFrames=(int)((currentAnimation.getEndTime()-currentAnimation.getStartTime())*currentAnimation.getFramesPerSecond());
		painter.setPen(QColor.black);
		for(int i=0;i<numFrames;i++) {
			int x=(int)(width()*i/(double)numFrames);
			painter.drawLine(x,0,x,height());
		}
		
		// TODO draw tracks
		
		painter.end();
	}
}
