/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Nov 28, 2005
 */
package eu.moonlight3d.ml3d.animation.basicselectiontypes;
/**
 *\package eu.moonlight3d.ml3d.modelling.basicselectiontypes
 * 
 * This plugin contains selection type filters for basic
 * operator graph and scene graph types.
 * 
 * This package is a separate plugin
 */

import java.util.ArrayList;

public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {

	public String getName() {
		return "eu.moonlight3d.ml3d.animation.basicselectiontypes.Plugin";
	}

	public ArrayList<String> getDependencies() {
		ArrayList<String> dependencies=new ArrayList<String>();
		dependencies.add("eu.moonlight3d.ml3d.backend.selection.Plugin");
		dependencies.add("eu.moonlight3d.ml3d.backend.threedim.Plugin");
		return dependencies;
	}

	public void load() throws Exception {
		eu.moonlight3d.ml3d.backend.selection.Manager.registerSelectionType(new AnimationType());
	}

	public void unload() throws Exception {
		eu.moonlight3d.ml3d.backend.selection.Manager.unregisterSelectionType("Animation");
	}

}
