/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Nov 28, 2005
 */
package eu.moonlight3d.ml3d.backend.selection;

/**
 * Interface for selection types. Selection types
 * are used to check if an object is of a certain
 * type so that it can be added to a selection of
 * that type. 
 *
 * @author gregor
 */
public interface SelectionType {
	/**
	 * Return the name of this selection type. This 
	 * is needed to distinguish between selection types.
	 * 
	 * @return name of this selection type
	 */
	public String getName();
	/**
	 * Check if the object type matches this selection
	 * type. Returns true if it maches, returns false
	 * otherwise. 
	 * 
	 * @param object the object to check
	 * @return true if type matches, false otherwise
	 */
	public boolean isThisType(Object object);
}
