package eu.moonlight3d.ml3d.backend.threedim;

import java.util.ArrayList;

import eu.moonlight3d.common.document.extensible.ExtensibleDocumentFactory;
import eu.moonlight3d.framework.document.DocumentManager;
import eu.moonlight3d.framework.helper.FileType;
import eu.moonlight3d.framework.localization.L10N;
import eu.moonlight3d.ml3d.backend.threedim.document.DocumentFactory;

public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {
	private ExtensibleDocumentFactory documentFactory;

	public ArrayList<String> getDependencies() {
		ArrayList<String> dependencies=new ArrayList<String>();
		
		dependencies.add("eu.moonlight3d.common.document.extensible.Plugin");
		dependencies.add("eu.moonlight3d.ml3d.backend.selection.Plugin");
		
		return dependencies;
	}

	public String getName() {
		return "eu.moonlight3d.ml3d.backend.threedim.Plugin";
	}

	public void load() throws Exception {
		// register document factory
		ArrayList<String> patterns=new ArrayList<String>();
		patterns.add("*.ml");
		FileType fileType=new FileType(L10N.translate("Moonlight|3D scene"),patterns);
		documentFactory=new DocumentFactory("MoonlightScene",L10N.translate("Moonlight|3D scene"),fileType);

		DocumentManager documentManager=eu.moonlight3d.framework.State.getInstance().getDocumentManager();
		documentManager.registerDocumentFactory(documentFactory);
		documentManager.setDefaultDocumentFactory(documentFactory.getTypeName());
	}

	public void unload() throws Exception {
		eu.moonlight3d.framework.State.getInstance().getDocumentManager().unregisterDocumentFactory(documentFactory);
	}

}
