/*
 * Moonlight|3D
 * Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package eu.moonlight3d.ml3d.backend.threedim.cache;

import java.util.HashMap;
import java.util.Map;

import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;


public class Manager {
	private HashMap<String,SceneGraph> cachedSGs;
	
	public Manager() {
		cachedSGs=new HashMap<String,SceneGraph>();
	}
	
	public void addSG(String identifier, SceneGraph sceneGraph) {
		cachedSGs.put(identifier,sceneGraph);
	}
	
	public SceneGraph getSG(String identifier) {
		return cachedSGs.get(identifier);
	}
	
	public Map<String,SceneGraph> getSGs() {
		return (HashMap<String, SceneGraph>) cachedSGs.clone();
	}
	
	public void removeSG(String identifier) {
		cachedSGs.remove(identifier);
	}
	
	public void clear() {
		cachedSGs.clear();
	}
}
