/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Dec 5, 2008
 */

package eu.moonlight3d.ml3d.backend.threedim.document;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import eu.moonlight3d.common.document.extensible.DocumentContribution;
import eu.moonlight3d.common.document.extensible.DocumentContributionFactory;
import eu.moonlight3d.common.document.extensible.ExtensibleDocument;
import eu.moonlight3d.framework.helper.PropertyContainer;

public class BackendContributionFactory implements DocumentContributionFactory {

	public String getName() {
		return "eu.moonlight3d.ml3d.backend.threedim.document.BackendContribution";
	}

	public DocumentContribution getNewContribution(ExtensibleDocument document, PropertyContainer properties) {
		BackendContribution contribution=new BackendContribution((eu.moonlight3d.ml3d.backend.threedim.document.Document) document);
		return contribution;
	}

	public DocumentContribution readContribution(ExtensibleDocument document, Document documentFile, Element contribution) {
		BackendContribution backendContribution=new BackendContribution((eu.moonlight3d.ml3d.backend.threedim.document.Document) document);
		try {
			backendContribution.read(documentFile, contribution);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return backendContribution;
	}

	public void registerNewContributionProperties(PropertyContainer container) {
		// no properties here
	}

}
