/*
 * Moonlight|3D Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Mar 14, 2007
 */
package eu.moonlight3d.ml3d.backend.threedim.document;

import java.util.ArrayList;

import eu.moonlight3d.common.document.extensible.ExtensibleDocument;
import eu.moonlight3d.common.document.extensible.ExtensibleDocumentFactory;
import eu.moonlight3d.framework.helper.FileType;
import eu.moonlight3d.framework.helper.PropertyContainer;

/**
 * Document factory for Moonlight|3D scene files
 *
 * @author gregor
 */
public class DocumentFactory extends ExtensibleDocumentFactory {

	public DocumentFactory(String typeName, String displayName, FileType fileType) {
		super(typeName, displayName, fileType);
		
		registerDocumentContributionFactory(new BackendContributionFactory());
	}

	@Override
	public Document createNewDocument(PropertyContainer options) {
		Document document=new Document(this);
		
		document.initialize(options);
		
		return document;
	}

	@Override
	public Document openDocument(String filename) throws Exception {
		return new Document(this,filename);
	}
}
