/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Nov 5, 2005
 */
package eu.moonlight3d.ml3d.backend.threedim.og;

import java.util.List;

public class DrainSlotIterator {
	private List<Node> ogNodes;
	private int currentNode;
	private int currentSlot;
	
	public DrainSlotIterator(Manager ogManager) {
		ogNodes=ogManager.getNodeList();
		currentNode=0;
		currentSlot=0;
	}
	
	private Slot getNext(boolean peek) {
		Slot result=null;
		
		List<Slot> slots;
		int node=currentNode;
		int slot=currentSlot;
		boolean doContinue=true;
		
		if(node<ogNodes.size()) {
			slots=ogNodes.get(node).getSlots();
		} else {
			return null;
		}
		
		while(node<ogNodes.size() && doContinue) {
			if(ogNodes.get(node).isDrain()) {
				while (slot < slots.size() && doContinue) {
					if (slots.get(slot).getType() == Slot.Type.Output) {
						result = slots.get(slot);
						slot++;
						doContinue = false;
						break;
					}
					slot++;
				}
				if(slot>=slots.size()) {
					node++;
					slot=0;
					if(node<ogNodes.size()) {
						slots=ogNodes.get(node).getSlots();
					}
				}
			} else {
				node++;
				slot=0;
				if(node<ogNodes.size()) {
					slots=ogNodes.get(node).getSlots();
				}
			}
			
		}
		
		if(!peek) {
			currentNode=node;
			currentSlot=slot;
		}
		
		return result;
	}
	
	public boolean hasNext()
	{
		if(getNext(true)!=null) {
			return true;
		} else {
			return false;
		}
	}
	
	public Slot next()
	{
		return getNext(false);
	}
}
