/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Dec 6, 2008
 */

package eu.moonlight3d.ml3d.backend.threedim.resource;

import org.w3c.dom.Element;

import eu.moonlight3d.framework.helper.NamedObject;
import eu.moonlight3d.ml3d.backend.selection.PathElement;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;

public abstract class Resource implements PathElement, NamedObject {
	private String name;
	private Document document;
	
	public abstract void write(org.w3c.dom.Document document, Element resourceElement);
	
	public abstract String getType();
	
	final public void setDocument(Document document) {
		this.document=document;
	}
	
	final public Document getDocument() {
		return document;
	}
	
	final public void setName(String name) {
		this.name=name;
	}
	
	final public String getName() {
		return name;
	}

	public PathElement findChildElement(String childName) {
		// resources usually do not have children
		return null;
	}

	public boolean isValidAppendixName(String appendix) {
		return false;
	}
	
	public Object getFromAppendix(String appendix) {
		return null;
	}
}
