/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Nov 3, 2005
 */
package eu.moonlight3d.ml3d.backend.threedim.sg.iterator;

import eu.moonlight3d.ml3d.backend.threedim.sg.Node;

public class TypeFilter implements Filter {
	private String typeName;
	private boolean allowSubclasses;
	
	public TypeFilter(String typeName, boolean allowSubclasses)
	{
		this.typeName=typeName;
		this.allowSubclasses=allowSubclasses;
	}

	public boolean check(Node node) {
		if(node.getClass().getName().equals(typeName)) {
			return true;
		}
		
		if(allowSubclasses) {
			Class nodeClass=node.getClass();
			while(!nodeClass.getName().equals("java.lang.Object")) {
				if(nodeClass.getName().equals(typeName)) {
					return true;
				}
				nodeClass=nodeClass.getSuperclass();
			}
		}
		
		return false;
	}

}
