/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Apr 19, 2006
 */
package eu.moonlight3d.ml3d.file.ml3d;

import java.util.ArrayList;

import eu.moonlight3d.common.file.core.FileFormat;
import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.helper.FileType;
import eu.moonlight3d.framework.helper.PropertyContainer;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;

/**
 * Support for the Wavefront .OBJ file format. Most of the
 * features related to polygon meshes are supported.
 *
 * @author gregor
 */
public class ML3DFileFormat extends FileFormat {

	@Override
	public FileType getFileType() {
		ArrayList<String> patterns=new ArrayList<String>();
		patterns.add("*.ml");
		return new FileType("Moonlight|3D 0.1.5/0.2.0",patterns);
	}

	@Override
	public boolean canImport() {
		return true;
	}

	@Override
	public boolean canExport() {
		return true;
	}

	@Override
	public PropertyContainer getImportProperties() {
		return null;
	}

	@Override
	public PropertyContainer getExportProperties() {
		return null;
	}

	@Override
	public void importFile(String filename) throws Exception {
        Document document=(Document) State.getInstance().getDocumentManager().createNewMainDocument("MoonlightScene");
        FileReader reader=new FileReader(document,filename);
        reader.run();
        
        document.update();
	}
	
	@Override
	public void exportFile(String filename) {
        Document document=(Document) State.getInstance().getDocumentManager().getMainDocument();
		FileWriter writer=new FileWriter(document,filename);
		try {
			writer.run();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
