/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Apr 19, 2006
 */
package eu.moonlight3d.ml3d.file.obj;

import java.util.ArrayList;

import eu.moonlight3d.common.file.core.Manager;

/**
 * Wavefront OBJ file format plugin
 *
 * @author gregor
 */
public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {

	public String getName() {
		return "eu.moonlight3d.ml3d.file.obj.Plugin";
	}

	public ArrayList<String> getDependencies() {
		ArrayList<String> dependencies=new ArrayList<String>();
		
		dependencies.add("eu.moonlight3d.common.file.core.Plugin");
		dependencies.add("eu.moonlight3d.ml3d.backend.selection.Plugin");
		dependencies.add("eu.moonlight3d.ml3d.backend.threedim.Plugin");
		dependencies.add("eu.moonlight3d.ml3d.modelling.mesh.Plugin");
		dependencies.add("eu.moonlight3d.ml3d.rendering.simple.Plugin");
		
		return dependencies;
	}

	public void load() throws Exception {
		Manager.getInstance().registerFileFormat(new OBJFileFormat());
	}

	public void unload() throws Exception {
		Manager.getInstance().unregisterFileFormat("Wavefront OBJ");
	}

}
