/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Dec 11, 2005
 */
package eu.moonlight3d.ml3d.images.png;
/**
 * \package eu.moonlight3d.ml3d.images.png
 * 
 * This is the plugin for loading and storing PNG image files.
 * 
 * This package is a standalone plugin. It depends on the the
 * libpng native libraries and the related JNI interface.
 */

import java.util.ArrayList;

import eu.moonlight3d.common.image.core.FormatManager;

public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {

	public String getName() {
		return "eu.moonlight3d.ml3d.images.png.Plugin";
	}

	public ArrayList<String> getDependencies() {
		ArrayList<String> dependencyList=new ArrayList<String>();
		dependencyList.add("eu.moonlight3d.common.image.core.Plugin");
		return dependencyList;
	}

	public void load() throws Exception {
		eu.moonlight3d.framework.State.getInstance().loadLibrary("png-java");
		
		FormatManager.getInstance().registerImageFormat(new ImageFormat());
	}

	public void unload() throws Exception {
		FormatManager.getInstance().unregisterImageFormat("PNG");
	}

}
