/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 13, 2005
 */
package eu.moonlight3d.ml3d.images.viewer;
/**
 * \package eu.moonlight3d.ml3d.images.viewer
 *
 * This plugin contains the viewer for rendered images.
 * 
 * This package is a standalone plugin.
 */

import java.util.ArrayList;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.ui.FrameLayout;
import eu.moonlight3d.framework.ui.MenuNode;
import eu.moonlight3d.framework.ui.UIManager;


/**
 * This is the plugin class for the UI test plugin
 * 
 * @author gregor
 */
public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#getName()
	 */
	public String getName() {
		return "eu.moonlight3d.ml3d.images.viewer.Plugin";
	}

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#getDependencies()
	 */
	public ArrayList<String> getDependencies() {
		ArrayList<String> dependencyList=new ArrayList<String>();		
		dependencyList.add("eu.moonlight3d.ml3d.ui.mainwindow.Plugin"); // for CloseCurrentFrameAction
		dependencyList.add("eu.moonlight3d.common.image.core.Plugin");
		return dependencyList;
	}

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#load()
	 */
	public void load() throws Exception {
		UIManager uiManager=State.getInstance().getUIManager();
		
		uiManager.registerMainWidgetFactory(new ImageViewFactory());
		uiManager.addOrReplaceLayout(new FrameLayout("imageviewer","Image Display"));
		
		State.getInstance().getUIManager().registerAction(new SaveImageAction(null));
		
		MenuNode contribution=new MenuNode(MenuNode.Type.Contribution,"ImageMenu","menubar");
		MenuNode imageMenu=new MenuNode(MenuNode.Type.Menu,"Image","");
		imageMenu.add(new MenuNode(MenuNode.Type.Entry,"Save Image...","SaveImageAction"));
		imageMenu.add(new MenuNode(MenuNode.Type.Separator,"",""));
		imageMenu.add(new MenuNode(MenuNode.Type.Entry,"Close","CloseCurrentFrameAction"));
		contribution.add(imageMenu);
		State.getInstance().getUIManager().getLayout("imageviewer").addMenuContribution(contribution);
	}

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#unload()
	 */
	public void unload() throws Exception {
		UIManager uiManager=State.getInstance().getUIManager();

		uiManager.unregisterMainWidgetFactory("imageview");
		
		State.getInstance().getUIManager().unregisterAction("SaveImageAction");
	}

}
