/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
package eu.moonlight3d.ml3d.modelling.basic;

import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.Slot;
import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;

public class CopyFromCache extends Node {
	private Property cachedGraph;
	
	public CopyFromCache() {
		super();
		createSlot("output",Slot.Type.Output);
		
		cachedGraph=new Property(this);
		cachedGraph.setName("cachedGraph");
		cachedGraph.setType(Property.Type.String);
		try {
			cachedGraph.setValue("OperatorGraph/none/output");
		} catch (Exception e) {
			// this cannot happen
			e.printStackTrace();
		}
	}
	
	@Override
	public void update() throws Exception {
		SceneGraph sg=getDocument().getCacheManager().getSG(cachedGraph.getStringValue());
		
		getSlot("output").setGraph(sg.deepCopy());
	}

	@Override
	public void removeDependencies() {
		try {
			getDocument().getCacheManager().removeSG(cachedGraph.getStringValue());
		} catch (Exception e) {
			// this should not happen and is not very critical if it does happen
			e.printStackTrace();
		}
	}

}
