/*
 * Moonlight|3D
 * Copyright (C) 2009 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Jan 3, 2009
 */

package eu.moonlight3d.ml3d.modelling.basic;

import eu.moonlight3d.math.Quaternion;
import eu.moonlight3d.math.Vector3D;
import eu.moonlight3d.ml3d.ui.mainwindow.widgets.GizmoSnapper;

public class GridGizmoSnapper implements GizmoSnapper {
	private boolean snapTranslationRelative=false;

	public Quaternion snapRotation(Vector3D center, Quaternion rotation) {
		double angle=rotation.getRotationAngle()*180/Math.PI;
		
		angle=5*Math.rint(angle/5);
		angle=Math.PI*angle/180.0;
		
		Quaternion snappedRotation=new Quaternion();
		snappedRotation.fromAxisAngle(rotation.getRotationAxis(), angle);
		
		return snappedRotation;
	}

	public Vector3D snapScale(Vector3D center, Vector3D scale) {
		Vector3D snappedScale=new Vector3D();

		snappedScale.X1=Math.rint(scale.X1*10.0)/10.0;
		snappedScale.X2=Math.rint(scale.X2*10.0)/10.0;
		snappedScale.X3=Math.rint(scale.X3*10.0)/10.0;
		
		return snappedScale;
	}

	public Vector3D snapTranslation(Vector3D start, Vector3D translation) {
		if(snapTranslationRelative) {
			Vector3D snapped=translation.clone();
			snapped.X1=Math.rint(snapped.X1);
			snapped.X2=Math.rint(snapped.X2);
			snapped.X3=Math.rint(snapped.X3);
			return snapped;			
		} else {
			Vector3D end=start.add(translation);
			
			end.X1=Math.rint(end.X1);
			end.X2=Math.rint(end.X2);
			end.X3=Math.rint(end.X3);
	
			return end.sub(start);
		}
	}

}
