/*
 * Moonlight|3D
 * Copyright (C) 2009 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Mar 23, 2009
 */

package eu.moonlight3d.ml3d.modelling.basic;

import java.text.MessageFormat;
import java.util.List;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.localization.L10N;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;

public class OGNodeElementCounter implements ElementCounter {

	public String getCount() {
		State state=State.getInstance();
		Document document=(Document) state.getDocumentManager().getMainDocument();
		
		List<eu.moonlight3d.ml3d.backend.threedim.og.Node> nodeList=document.getOGManager().getNodeList();
		int totalCount=nodeList.size();
		
		int sourceCount=0;
		int drainCount=0;
		for(eu.moonlight3d.ml3d.backend.threedim.og.Node node : nodeList) {
			if(node.isDrain()) {
				drainCount++;
			} else if(node.isSource()) {
				sourceCount++;
			}
		}
		
		String result;
		
		result=MessageFormat.format(L10N.translate("{0} total ({1} sources, {2} drains)"), totalCount,sourceCount,drainCount);
		
		return result;
	}

	public String getLabel() {
		return L10N.translate("Operator Graph Nodes: ");
	}

}
