/*
 * Moonlight|3D
 * Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on May 8, 2007
 */

package eu.moonlight3d.ml3d.modelling.basic;

import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.localization.L10N;
import eu.moonlight3d.framework.ui.Action;
import eu.moonlight3d.ml3d.ui.mainwindow.toolchest.ToolChestView;


public class TranslateAction extends Action {
	TranslateAction(QWidget parent) {
		super("TranslateAction",L10N.translate("Translate"),parent);
		setShortcut("w");
		triggered.connect(this,"run()");
	}
	
	@Override
	public void run() {
		TransformTool transformTool=(TransformTool) ToolChestView.getToolByName("TransformTool");
		transformTool.setTranslateEnabled(true);
		transformTool.setRotateEnabled(false);
		transformTool.setScaleEnabled(false);
		ToolChestView.activateTool("TransformTool");
	}
}
