/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 31, 2006
 */
package eu.moonlight3d.ml3d.modelling.camera;

import eu.moonlight3d.ml3d.backend.threedim.sg.Node;
import eu.moonlight3d.ml3d.ui.mainwindow.view.LightSource;
import eu.moonlight3d.ml3d.ui.mainwindow.view.SGNodeConverter;
import eu.moonlight3d.ml3d.ui.mainwindow.view.SceneNode;


public class CameraConverter implements SGNodeConverter {

	public boolean canConvertNode(Node node) {
		if(node instanceof eu.moonlight3d.ml3d.modelling.camera.Camera) {
			return true;
		}
		return false;
	}

	public SceneNode[] convert(Node node) {
		Camera cameraNode=(Camera)node;
		CameraRenderable camera=new CameraRenderable(cameraNode.getPosition(),cameraNode.getFront(),cameraNode.getUp(),cameraNode.getRight());
		SceneNode[] results=new SceneNode[1];
		results[0]=camera;
		return results;
	}

	public LightSource[] convertLights(Node node) {
		return null;
	}
}
