/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 29, 2005
 */
package eu.moonlight3d.ml3d.modelling.camera;

import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.Slot;
import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;

/**
 * An operator graph node that creates a camera.
 *
 * @author gregor
 */
public class CreateCamera extends Node {
    private Property name;

    public CreateCamera()
    {
    	super();
        createSlot("output",Slot.Type.Output);
        name=new Property(this);
        name.setName("name");
        name.setType(Property.Type.String);
        try {
            name.setValue("Camera");
        } catch (Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();
        }
    }
    
    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.backend.og.Node#update()
     */
    @Override
    public void update() throws Exception
    {
    	SceneGraph sceneGraph=new SceneGraph(getDocument());
        eu.moonlight3d.ml3d.backend.threedim.sg.Instance instance;
        Camera camera;
        
        instance=new eu.moonlight3d.ml3d.backend.threedim.sg.Instance();
        instance.setName(name.getStringValue() + "Instance");

        camera=new Camera();
        
        camera.setName(name.getStringValue());
        
        sceneGraph.addNode(instance);
        sceneGraph.addNode(camera);
        sceneGraph.addChild(instance,camera);
        
        getSlot("output").setGraph(sceneGraph);
    }

	@Override
	public void removeDependencies() {
	}
}
