/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 31, 2006
 */
package eu.moonlight3d.ml3d.modelling.mesh;

import java.text.MessageFormat;

import eu.moonlight3d.framework.localization.L10N;
import eu.moonlight3d.ml3d.backend.threedim.sg.Node;
import eu.moonlight3d.ml3d.ui.mainwindow.view.LightSource;
import eu.moonlight3d.ml3d.ui.mainwindow.view.SGNodeConverter;
import eu.moonlight3d.ml3d.ui.mainwindow.view.SceneNode;

/**
 * This class converts meshes to a representation that is renderable
 * in the 3D view.
 * 
 * @see eu.moonlight3d.ml3d.ui.mainwindow.view.SGNodeConverter
 *
 * @author gregor
 */
public class MeshConverter implements SGNodeConverter {
	public boolean canConvertNode(Node node) {
		if(node instanceof eu.moonlight3d.ml3d.modelling.mesh.Mesh) {
			return true;
		}
		return false;
	}

	public SceneNode[] convert(Node node) {
		try {
			MeshRenderable mesh=new MeshRenderable((Mesh) node);

			SceneNode[] results=new SceneNode[1];
			results[0]=mesh;
			return results;
		} catch(Exception e) {
			// log this error, but try to do damage control
			String message=MessageFormat.format(L10N.translate("failed to convert SG Mesh node {0}: {1}"), node.getName(),e.getMessage());
			eu.moonlight3d.framework.State.getInstance().logger().severe(message);
			e.printStackTrace();
		}
		return null;
	}

	public LightSource[] convertLights(Node node) {
		return null;
	}
}
