/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Mar 15, 2005
 */
package eu.moonlight3d.ml3d.modelling.objects;

import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.Slot;
import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;

public class DeleteObjects extends Node {
    public Property name;

    public DeleteObjects()
    {
        super();

        createSlot("input",Slot.Type.Input);
        createSlot("output",Slot.Type.Output);

        name=new Property(this);
        name.setName("name");
        name.setType(Property.Type.StringArray);
        try {
            name.setMaxSize(0);
        } catch (Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();
        }
    }
    
    private void deleteNode(SceneGraph graph, eu.moonlight3d.ml3d.backend.threedim.sg.Node node) {
    	for(eu.moonlight3d.ml3d.backend.threedim.sg.Node child : node.getChildren()) {
    		graph.removeChild(node, child);
    		if(child.getParents().size()==0) {
    			deleteNode(graph,child);
    		}
    	}
    	for(eu.moonlight3d.ml3d.backend.threedim.sg.Node parent : node.getParents()) {
    		graph.removeChild(parent, node);
    	}
        graph.removeNode(node);    	
    }

    @Override
    public void update() throws Exception
    {
        SceneGraph graph;
        
        graph=getSlot("input").getGraph();
        for(int i=0;i<name.getSize();i++) {
        	eu.moonlight3d.ml3d.backend.threedim.sg.Node node=graph.getNodeByName(name.getArrayStringValue(i));
        	deleteNode(graph,node);
        }
        getSlot("output").setGraph(graph);
    }

	@Override
	public void removeDependencies() {
	}

}
