/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Apr 21, 2008
 */

package eu.moonlight3d.ml3d.modelling.objects;

import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.framework.helper.Value;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.Slot;
import eu.moonlight3d.ml3d.backend.threedim.sg.Group;
import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;

public class GroupObjects extends Node {
	private Property objects;
	private Property name;
	
	/**
	 * Default constructor
	 */
	public GroupObjects() {
		createSlot("input",Slot.Type.Input);
		createSlot("output",Slot.Type.Output);
		
		objects=new Property(this);
		objects.setName("objects");
		objects.setType(Value.Type.StringArray);
		objects.setMaxSize(0);
		
		name=new Property(this);
		name.setName("name");
		name.setType(Value.Type.String);
		name.setValue("Group");
	}

	@Override
	public void update() throws Exception {
		SceneGraph graph=getSlot("input").getGraph();
		
		// create group node, reparent objects
		Group group=new Group();
		group.setName(name.getStringValue());
		graph.addNode(group);
		
		// TODO discover common parent of objects if any
		
		for(int i=0;i<objects.getSize();i++) {
			eu.moonlight3d.ml3d.backend.threedim.sg.Node node=graph.getNodeByName(objects.getArrayStringValue(i));
			graph.addChild(group, node);
			// TODO remove node from old parent if any
			String[] path=objects.getArrayStringValue(i).split("/");
			if(path.length>1) {
				graph.removeChild(graph.getNodeByName(path[path.length-2]), node);
			}
		}
		
		getSlot("output").setGraph(graph);
	}

	@Override
	public void removeDependencies() {
	}
}
