/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Dec 6, 2008
 */

package eu.moonlight3d.ml3d.modelling.textures;

import org.w3c.dom.Element;

import eu.moonlight3d.ml3d.backend.threedim.resource.Resource;
import eu.moonlight3d.ml3d.backend.threedim.resource.ResourceFactory;

public class TextureFactory implements ResourceFactory {

	public String getType() {
		return "Texture";
	}

	public Resource loadResource(String name, String filename) {
		Texture texture=new Texture();
		texture.setName(name);
		try {
			texture.load(filename);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return texture;
	}

	public Resource readResource(String name, Element resourceElement) {
		// TODO Auto-generated method stub
		Texture texture=new Texture();
		texture.setName(name);
		try {
			texture.read(resourceElement);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return texture;
	}

}
