/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jul 6, 2006
 */
package eu.moonlight3d.ml3d.rendering.glsl;


import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.ui.Action;

public class AddShaderParameterAction extends Action {
	public AddShaderParameterAction(QWidget parent) {
		super("AddShaderParameterAction","Add shader parameter",parent);
		triggered.connect(this,"run()");
	}

	@Override
	public void run() {
		if(GLSLEditor.getInstance()==null) {
			State.getInstance().logger().warning("Add shader parameter tool activated without existing GLSL editor");
			return;
		}
		CreateGLSLShader createGLSLShaderNode=GLSLEditor.getInstance().getCreateGLSLShaderNode();
		if(createGLSLShaderNode==null) {
			State.getInstance().logger().warning("No shader selected in GLSL editor");
			return;
		}
		
		QWidget window=eu.moonlight3d.framework.State.getInstance().getUIManager().getActiveApplicationWindow();
		AddShaderParameterDialog addShaderParameterDialog=new AddShaderParameterDialog(window,createGLSLShaderNode);
		
		addShaderParameterDialog.show();
	}
}
