/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Dec 4, 2005
 */
package eu.moonlight3d.ml3d.rendering.glsl;

import eu.moonlight3d.ml3d.backend.threedim.sg.Node;

public class GLSLProgram extends Node {
	public enum Type {
		Vertex,
		Fragment
	}
	
	private String program;
	private Type type;

	public GLSLProgram() {
		super();
		program="";
		type=Type.Vertex;
	}
	
	public void setProgram(String program) {
		this.program=program;
	}
	
	public String getProgram() {
		return program;
	}
	
	public void setProgramType(Type type) {
		this.type=type;
	}
	
	public Type getProgramType() {
		return type;
	}
	
	public boolean isValidAppendixName(String appendix) {
		if(appendix.equals("program")) {
			return true;
		}
		return false;
	}

	public Object getFromAppendix(String appendix) {
		if(appendix.equals("program")) {
			return program;
		}
		return null;
	}

	@Override
	public String getType() {
		return "GLSLProgram";
	}

}
