/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jul 6, 2006
 */
package eu.moonlight3d.ml3d.rendering.glsl;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


import com.trolltech.qt.gui.QFileDialog;
import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.ui.Action;

public class LoadShaderAction extends Action {
	public LoadShaderAction(QWidget parent) {
		super("LoadShaderAction","Load Shader",parent);
		triggered.connect(this,"run()");
	}
	
	@Override
	public void run() {
		if(GLSLEditor.getInstance()==null) {
			State.getInstance().logger().warning("Add shader parameter tool activated without existing GLSL editor");
			return;
		}
		CreateGLSLShader createGLSLShaderNode=GLSLEditor.getInstance().getCreateGLSLShaderNode();
		if(createGLSLShaderNode==null) {
			State.getInstance().logger().warning("No shader selected in GLSL editor");
			return;
		}
		
		String filename;
		QFileDialog.Filter filter=new QFileDialog.Filter("GLSL shader (*.glsl);; All files (*);;");
		
		filename=QFileDialog.getOpenFileName(eu.moonlight3d.framework.State.getInstance().getUIManager().getActiveApplicationWindow(),"Load GLSL shader code","",filter);
		if(filename.equals("")) {
			return;
		}
		
		try {
			BufferedReader reader=new BufferedReader(new FileReader(filename));
			String text="";
			String line;
			
			do {
				if(!text.equals("")) {
					text=text+"\n";
				}
				line=reader.readLine();
				if(line!=null) {
					text=text+line;
				}
			} while(line!=null);
			// TODO load shader file
			
			GLSLEditor.getInstance().setShaderText(text);
			
		} catch (IOException e) {
			eu.moonlight3d.framework.ui.ExceptionDialog.run(new Exception("an error occured while loading a new shader",e));
		}
	}
}
