/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jul 6, 2006
 */
package eu.moonlight3d.ml3d.rendering.glsl;


import com.trolltech.qt.gui.QDialog;
import com.trolltech.qt.gui.QHBoxLayout;
import com.trolltech.qt.gui.QListWidget;
import com.trolltech.qt.gui.QPushButton;
import com.trolltech.qt.gui.QVBoxLayout;
import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.helper.Property;

public class RemoveShaderParameterDialog extends QDialog {
	private QListWidget parameterList;
	private CreateGLSLShader createGLSLShaderNode;
	
	protected RemoveShaderParameterDialog(QWidget parent, CreateGLSLShader createGLSLShaderNode) {
		super(parent);
		this.createGLSLShaderNode=createGLSLShaderNode;

		setWindowTitle("Remove shader parameter");
		
		parameterList=new QListWidget();
		Property parameterNames;
		parameterNames=createGLSLShaderNode.getProperty("boolUniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("intUniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("floatUniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("vec2UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("vec3UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("vec4UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("bvec2UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("bvec3UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("bvec4UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("ivec2UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("ivec3UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("ivec4UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("mat2UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("mat3UniformNames");
		appendNamesToTable(parameterNames);
		parameterNames=createGLSLShaderNode.getProperty("mat4UniformNames");
		appendNamesToTable(parameterNames);

		QPushButton cancel=new QPushButton(this);
		cancel.setText("Cancel");
		cancel.clicked.connect(this,"close()");

		QPushButton ok=new QPushButton(this);
		ok.setText("OK");
		ok.clicked.connect(this,"handleOK()");
		
		QVBoxLayout layout=new QVBoxLayout();
		QHBoxLayout bottomLayout=new QHBoxLayout();
		
		bottomLayout.addStretch(1);
		bottomLayout.addWidget(cancel);
		bottomLayout.addWidget(ok);
		
		layout.addWidget(parameterList,1);
		layout.addLayout(bottomLayout);
		
		setLayout(layout);
	}
	
	void appendNamesToTable(Property parameterNames) {
		try {
			for(int i=0;i<parameterNames.getSize();i++) {
				parameterList.addItem(parameterNames.getArrayStringValue(i));
			}
		} catch(Exception e) {
			// should not happen here
			e.printStackTrace();
		}
	}
	
	private void processInput() {
		// TODO
	}
	
	public void handleOK() {
		processInput();
		close();
	}
}
