/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jul 6, 2006
 */
package eu.moonlight3d.ml3d.rendering.glsl;

import java.io.IOException;
import java.io.PrintWriter;


import com.trolltech.qt.gui.QFileDialog;
import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.ui.Action;

public class SaveShaderAction extends Action {
	public SaveShaderAction(QWidget parent) {
		super("SaveShaderAction","Save Shader",parent);
		triggered.connect(this,"run()");
	}
	
	@Override
	public void run() {
		if(GLSLEditor.getInstance()==null) {
			State.getInstance().logger().warning("Add shader parameter tool activated without existing GLSL editor");
			return;
		}
		CreateGLSLShader createGLSLShaderNode=GLSLEditor.getInstance().getCreateGLSLShaderNode();
		if(createGLSLShaderNode==null) {
			State.getInstance().logger().warning("No shader selected in GLSL editor");
			return;
		}

		String text=GLSLEditor.getInstance().getShaderText();
		
		String filename;
		QFileDialog.Filter filter=new QFileDialog.Filter("GLSL shader (*.glsl)");
		
		filename=QFileDialog.getSaveFileName(eu.moonlight3d.framework.State.getInstance().getUIManager().getActiveApplicationWindow(),"Save GLSL shader code","",filter);
		if(filename.equals("")) {
			return;
		}
		
		try {
			PrintWriter writer=new PrintWriter(filename);
			writer.print(text);
			writer.close();
		} catch (IOException e) {
			eu.moonlight3d.framework.ui.ExceptionDialog.run(new Exception("an error occured while saving the current shader",e));
		}
	}
}
