/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jul 1, 2006
 */
package eu.moonlight3d.ml3d.rendering.glsl;

import eu.moonlight3d.framework.helper.NamedObject;
import eu.moonlight3d.framework.helper.Value;

public class Uniform extends Value implements NamedObject {
	private String name;
	
	public enum GLSLType {
		Bool,
		Int,
		Float,
		Vec2,
		Vec3,
		Vec4,
		BVec2,
		BVec3,
		BVec4,
		IVec2,
		IVec3,
		IVec4,
		Mat2,
		Mat3,
		Mat4,
		Sampler1D,
		Sampler2D,
		Sampler3D,
		SamplerCube,
		Sampler1DShadow,
		Sampler2DShadow
	}
	
	private GLSLType glslType;

	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name=name;
	}
	
	public void setGLSLType(GLSLType type) {
		this.glslType=type;
	}
	
	public GLSLType getGLSLType() {
		return glslType;
	}
}
