/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Sep 28, 2006
 */
package eu.moonlight3d.ml3d.rendering.materialgraph;

import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.framework.helper.Value;

public class ConstantValueNode extends MaterialGraphNode {
	private Property value;
	
	public ConstantValueNode() {
		value=new Property(this);
		value.setName("value");
		value.setType(Value.Type.Float);
		try {
			value.setValue(0.0);
		} catch (Exception e) {
			// this cannot happen here
			e.printStackTrace();
		}
		createSlot("output",MaterialGraphSlot.Type.Output);
	}
	
	@Override
	public void evaluate(RendererInterface renderer) {
		try {
			getSlot("output").setValue(value.clone());
		} catch (Exception e) {
			// this cannot happen here because typesafety is guaranteed
			e.printStackTrace();
		}
	}

}
