/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Sep 28, 2006
 */
package eu.moonlight3d.ml3d.rendering.materialgraph;

import eu.moonlight3d.framework.helper.Value;

public class GeometryNormalNode extends MaterialGraphNode {
	public GeometryNormalNode() {
		createSlot("output",MaterialGraphSlot.Type.Output);
	}
	
	@Override
	public void evaluate(RendererInterface renderer) {
		try {
			Value value=new Value();
			value.setType(Value.Type.Vector3D);
			value.setValue(renderer.getCurrentNormal());
			getSlot("output").setValue(value);
		} catch (Exception e) {
			// should not happen - type safety is guaranteed
			e.printStackTrace();
		}
	}
}
