/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Sep 27, 2006
 */
package eu.moonlight3d.ml3d.rendering.materialgraph;

import java.util.ArrayList;
import java.util.List;


import org.w3c.dom.Document;
import org.w3c.dom.Element;

import eu.moonlight3d.framework.helper.DefaultFactory;
import eu.moonlight3d.framework.helper.Factory;
import eu.moonlight3d.framework.helper.NamePool;
import eu.moonlight3d.ml3d.backend.threedim.sg.MaterialNode;

public class MaterialGraph extends MaterialNode {
	private static ArrayList<Factory> factories=null;
	
	public static void addNodeFactory(Factory factory) {
		if(factories==null) {
			factories=new ArrayList<Factory>();
		}
		factories.add(factory);
	}
	
	public static void removeNodeFactory(String factoryName) {
		for(Factory factory : factories) {
			if(factory.getName().equals(factoryName)) {
				factories.remove(factory);
				return;
			}
		}
	}
	
	public static List<String> getNodeFactoryNames() {
		ArrayList<String> factoryNames=new ArrayList<String>();
		for(Factory factory : factories) {
			factoryNames.add(factory.getName());
		}
		return factoryNames;
	}
	
	static {
		addNodeFactory(new DefaultFactory("Add",AddNode.class));
		addNodeFactory(new DefaultFactory("Constant Colour",ConstantColourNode.class));
		addNodeFactory(new DefaultFactory("Constant Value",ConstantValueNode.class));
		addNodeFactory(new DefaultFactory("Diffuse Shader",DiffuseShaderNode.class));
		addNodeFactory(new DefaultFactory("Geometry Normal",GeometryNormalNode.class));
		addNodeFactory(new DefaultFactory("Position",PositionNode.class));
		addNodeFactory(new DefaultFactory("Specular Shader",SpecularShaderNode.class));
		addNodeFactory(new DefaultFactory("Subtract",SubtractNode.class));
		addNodeFactory(new DefaultFactory("Texture",TextureNode.class));
		addNodeFactory(new DefaultFactory("UV Mapping",UVMappingNode.class));
	}
	
	private ArrayList<MaterialGraphNode> nodes;
	private NamePool nodeNames;

	public MaterialGraph() {
		super();
		nodes=new ArrayList<MaterialGraphNode>();
		nodeNames=new NamePool();
	}
	
	public MaterialGraphNode createNode(String nodeType) {
		// TODO
		return null;
	}
	
	public void removeNode(MaterialGraphNode node) {
		nodes.remove(node);
	}
	
	public MaterialGraphNode getNodeByName(String name) {
		for(MaterialGraphNode node : nodes) {
			if(node.getName().equals(name)) {
				return node;
			}
		}
		return null;
	}
	
	public List<MaterialGraphNode> getNodes() {
		return (List<MaterialGraphNode>) nodes.clone();
	}
	
	public void evaluate(RendererInterface renderer) {
		// TODO
	}
	
	@Override
	public String getType() {
		return "MaterialGraph";
	}

	public Object getFromAppendix(String appendix) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isValidAppendixName(String appendix) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void loadXMLData(Element dataElement) {
		// TODO
	}

	@Override
	public void saveXMLData(Document document, Element dataElement) {
		// TODO
	}
}
