/*
 * Moonlight|3D Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Feb 22, 2007
 */
package eu.moonlight3d.ml3d.rendering.materialgraph;

import java.util.List;


import com.trolltech.qt.core.Qt;
import com.trolltech.qt.gui.QComboBox;
import com.trolltech.qt.gui.QListWidget;
import com.trolltech.qt.gui.QListWidgetItem;
import com.trolltech.qt.gui.QSplitter;
import com.trolltech.qt.gui.QVBoxLayout;
import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.common.ui.propertysheet.PropertySheet;
import eu.moonlight3d.graph.GraphModel;
import eu.moonlight3d.graph.GraphModelListener;
import eu.moonlight3d.graph.GraphView;
import eu.moonlight3d.graph.Node;

public class MaterialGraphEditor extends QWidget implements GraphModelListener {
	private QComboBox materials;
	private QListWidget nodeList;
	private GraphView graphView;
	private PropertySheet propertySheet;
	
	private MaterialGraph materialGraph;
	private ModelGenerator modelGenerator;
	
	
	private class SelectionListener implements eu.moonlight3d.ml3d.backend.selection.SelectionListener {

		public void elementAdded(String objectName) {
			// TODO Auto-generated method stub
			
		}

		public void elementRemoved(String objectName) {
			// TODO Auto-generated method stub
			
		}

		public void elementUpdated(String oldName, String newName) {
			// TODO Auto-generated method stub
			
		}

		public void elementsAdded(List<String> objectNames) {
			// TODO Auto-generated method stub
			
		}

		public void selectionCleared() {
			// TODO Auto-generated method stub
			
		}

	}
	
	private SelectionListener selectionListener;
	
	private class LifecycleListener implements eu.moonlight3d.framework.document.LifecycleListener {

		public void afterNew() {
			// TODO Auto-generated method stub
			
		}

		public void afterOpen(String filename) {
			// TODO Auto-generated method stub
			
		}

		public void afterSave(String filename) {
			// TODO Auto-generated method stub
			
		}

		public void beforeNew() {
			// TODO Auto-generated method stub
			
		}

		public void beforeOpen(String filename) {
			// TODO Auto-generated method stub
			
		}

		public void beforeSave(String filename) {
			// TODO Auto-generated method stub
			
		}

		public void onClose() {
			// TODO Auto-generated method stub
			
		}
		
	}
	
	private LifecycleListener lifecycleListener;

	public MaterialGraphEditor(QWidget parent) {
		super(parent);
		
		modelGenerator=new ModelGenerator();
		
		materials=new QComboBox(this);
		materials.setEditable(false);
		materials.currentIndexChanged.connect(this,"materialChanged()");

		QSplitter splitter=new QSplitter(this);
		splitter.setOrientation(Qt.Orientation.Horizontal);
		nodeList=new QListWidget(splitter);
		nodeList.itemDoubleClicked.connect(this,"nodeListDoubleClicked(QListWidgetItem)");
		for(String typeName : MaterialGraph.getNodeFactoryNames()) {
			nodeList.addItem(typeName);
		}
		graphView=new GraphView(splitter);
		graphView.setGraphModel(modelGenerator.getGraphModel());
		propertySheet=new PropertySheet(splitter);
		
		splitter.setStretchFactor(0, 0);
		splitter.setStretchFactor(1, 3);
		splitter.setStretchFactor(2, 0);
		
		QVBoxLayout layout=new QVBoxLayout();
		layout.addWidget(materials);
		layout.addWidget(splitter);
		layout.setMargin(0);
		setLayout(layout);
	}
	
	protected void materialChanged() {
		// TODO set new material graph node in model generator
		materialGraph=(MaterialGraph) materials.itemData(materials.currentIndex());
		modelGenerator.setMaterialGraph(materialGraph);
		propertySheet.setPropertyContainer(null);
	}

	protected void nodeListDoubleClicked(QListWidgetItem item) {
		// TODO add node to material graph (how? through operator graph node?)
		if(materialGraph==null) {
			return;
		}
	}

	public void handleSelection(GraphModel model, Node node, boolean selected) {
		// update property sheet with new node
		if(materialGraph==null) {
			return;
		}
		if(selected) {
			propertySheet.setPropertyContainer(materialGraph.getNodeByName(node.getName()));
		}
	}
}
