/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Sep 27, 2006
 */
package eu.moonlight3d.ml3d.rendering.materialgraph;

import eu.moonlight3d.framework.helper.Value;

public class MaterialGraphSlot {
	public enum Type {
		Input,
		Output
	}
	
	private String name;
	private Type type;
	private MaterialGraphSlot connectedSlot;
	private Value value;

	public MaterialGraphSlot(String name, Type type) {
		this.type=type;
		this.name=name;
	}
	
	public String getName() {
		return name;
	}
	
	public Type getType() {
		return type;
	}

	public MaterialGraphSlot getConnectedSlot() {
		return connectedSlot;
	}

	public void setConnectedNode(MaterialGraphSlot connectedSlot) {
		this.connectedSlot = connectedSlot;
		if(connectedSlot!=null) {
			connectedSlot.connectedSlot=this;
		}
	}

	public Value getValue() {
		if(type==Type.Input) {
			if(connectedSlot!=null) {
				return connectedSlot.getValue();
			} else {
				return null;
			}
		} else {
			return value;
		}
	}

	public void setValue(Value value) throws Exception {
		if(type==Type.Input) {
			throw new Exception("cannot set value on an input slot");
		}
		this.value = value;
	}
}
