/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Sep 27, 2006
 */
package eu.moonlight3d.ml3d.rendering.materialgraph;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.math.Ray;
import eu.moonlight3d.math.Vector3D;

public interface RendererInterface {
	public Vector3D getCurrentPosition();
	public Vector3D getCurrentNormal();
	public Ray getCurrentRay();
	// TODO: surface shape, (area) light sources
	public Colour shootRay(Ray ray); // shouldn't this be able to return more data than a simple Colour?
	
	public void setOutputColour(Colour colour);
	// TODO: other possible return values (depth bias perhaps?)
}
