/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 29, 2005
 */
package eu.moonlight3d.ml3d.rendering.simple;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.Slot;
import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;

/**
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 *
 * @author gregor
 */
public class CreateTextureMaterial extends Node {
    private Property name;
    private Property ownerName;
    private Property textureName;
    private Property uvSetName;

    public CreateTextureMaterial()
    {
        createSlot("input",Slot.Type.Input);
        createSlot("output",Slot.Type.Output);
        name=new Property(this);
        name.setName("name");
        name.setType(Property.Type.String);
        try {
            name.setValue("Material");
        } catch (Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();
        }
        ownerName=new Property(this);
        ownerName.setName("ownerName");
        ownerName.setType(Property.Type.String);
        try {
            ownerName.setValue("Mesh");
        } catch (Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();
        }
        textureName=new Property(this);
        textureName.setName("textureName");
        textureName.setType(Property.Type.String);
        try {
            textureName.setValue("Texture");
        } catch(Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();            
        }
        uvSetName=new Property(this);
        uvSetName.setName("uvSetName");
        uvSetName.setType(Property.Type.String);
        try {
            uvSetName.setValue("UVMap");
        } catch(Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();            
        }
    }
    
    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.backend.og.Node#update()
     */
    @Override
    public void update() throws Exception
    {
        SceneGraph graph;
        eu.moonlight3d.ml3d.backend.threedim.sg.Node owner;
        TextureMaterial textureMaterial;
        
        graph=getSlot("input").getGraph();
        owner=graph.getNodeByName(ownerName.getStringValue());
        
        textureMaterial=(TextureMaterial) graph.createNode("TextureMaterial",name.getStringValue());

        textureMaterial.setTextureName(textureName.getStringValue());
        textureMaterial.setUVSetName(uvSetName.getStringValue());
        
        graph.addNode(textureMaterial);
        graph.addChild(owner, textureMaterial);
      
        getSlot("output").setGraph(graph);
    }

	@Override
	public void removeDependencies() {
	}
}
