/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on May 3, 2006
 */
package eu.moonlight3d.ml3d.rendering.simple;

import javax.media.opengl.GL;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.ml3d.ui.mainwindow.view.MaterialNode;


public class GLSimpleMaterial extends MaterialNode {
	private Colour colour;

	public GLSimpleMaterial() {
		colour=new Colour();
	}
	
	@Override
	public int getNumPasses(GL gl) {
		// there is always only one pass for a simple material
		return 1;
	}

	@Override
	public String getUVMapForPass(GL gl, int numPass) {
		return null;
	}

	@Override
	public void doPass(GL gl, int numPass) {
		Colour.RGB sRGB=colour.getsRGB8();
		gl.glColor3d(sRGB.red/256.0,sRGB.green/256.0,sRGB.blue/256.0);
	}

	@Override
	public void reset(GL gl) {
		gl.glColor3d(1.0,1.0,1.0);
	}
	
	public void setColour(Colour colour) {
		this.colour=colour.clone();
	}
}
