/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Dec 29, 2008
 */

package eu.moonlight3d.ml3d.rendering.simple;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;

/**
 * A @see LifecycleListener implementation used for registering
 * the removal check required for textures in the presence of
 * texture materials. 
 *
 * @author gregor
 */
public class LifecycleListener implements eu.moonlight3d.framework.document.LifecycleListener {

	public void afterNew() {
		Document document=(Document) State.getInstance().getDocumentManager().getMainDocument();
		document.getResourceManager().registerResourceRemoveCheck(new TextureRemoveCheck(document));
	}

	public void afterOpen(String filename) {
		Document document=(Document) State.getInstance().getDocumentManager().getMainDocument();
		document.getResourceManager().registerResourceRemoveCheck(new TextureRemoveCheck(document));
	}

	public void afterSave(String filename) {
	}

	public void beforeNew() {
	}

	public void beforeOpen(String filename) {
	}

	public void beforeSave(String filename) {
	}

	public void onClose() {
	}

}
