/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Dec 6, 2008
 */

package eu.moonlight3d.ml3d.rendering.simple;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.ml3d.backend.threedim.sg.MaterialNode;

public class TextureMaterial extends MaterialNode {
	private String textureName;
	private String uvSetName;
	
    public TextureMaterial() 
    {
    	textureName="Texture";
    }
    
    public void setTextureName(String textureName) {
    	this.textureName=textureName;
    }
    
    public String getTextureName() {
    	return textureName;
    }
    
    public void setUVSetName(String uvSetName) {
    	this.uvSetName=uvSetName;
    }
    
    public String getUVSetName() {
    	return uvSetName;
    }
    
    @Override
	public eu.moonlight3d.ml3d.backend.threedim.sg.Node clone() {
    	TextureMaterial m=(TextureMaterial)super.clone();
    	m.textureName=textureName;
    	return m;
    }
    
    public boolean isValidAppendixName(String appendix)
    {
        if(appendix.equals("texture")) {
            return true;
        } else {
            return false;
        }
    }

    public Object getFromAppendix(String appendix)
    {
        if(appendix.equals("texture")) {
            return textureName;
        } 
        return null;
    }

	@Override
	public String getType() {
		return "TextureMaterial";
	}

	@Override
	protected void loadXMLData(Element dataElement) {
		Element textureElement=(Element) dataElement.getElementsByTagName("texture").item(0);
		textureName=textureElement.getAttribute("name");
		Element uvSetElement=(Element) dataElement.getElementsByTagName("uvset").item(0);
		uvSetName=uvSetElement.getAttribute("name");
	}
	
	@Override
	protected void saveXMLData(Document document, Element dataElement) {
		Element textureElement=document.createElement("texture");
		textureElement.setAttribute("name",textureName);
		dataElement.appendChild(textureElement);

		Element uvSetElement=document.createElement("uvset");
		uvSetElement.setAttribute("name",uvSetName);
		dataElement.appendChild(uvSetElement);
	}
}
