/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Feb 16, 2006
 */
package eu.moonlight3d.ml3d.rendering.simple;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;
import eu.moonlight3d.ml3d.backend.threedim.sg.Node;
import eu.moonlight3d.ml3d.modelling.textures.Texture;
import eu.moonlight3d.ml3d.ui.mainwindow.view.LightSource;
import eu.moonlight3d.ml3d.ui.mainwindow.view.SGNodeConverter;
import eu.moonlight3d.ml3d.ui.mainwindow.view.SceneNode;


/**
 * A scene graph node converter that takes care that assigned textures
 * get rendered properly.
 *
 * @author gregor
 */
public class TextureMaterialConverter implements SGNodeConverter {

	public boolean canConvertNode(Node node) {
		if(node instanceof TextureMaterial) {
			return true;
		}
		
		return false;
	}


	public SceneNode[] convert(Node node) {
		TextureMaterial textureNode=(TextureMaterial) node;

		Document document=(Document) State.getInstance().getDocumentManager().getMainDocument();
		Texture texture=(Texture) document.getResourceManager().getResource(textureNode.getTextureName());
		GLTextureMaterial textureMaterial=new GLTextureMaterial(texture.getImage(),textureNode.getUVSetName());

		SceneNode[] results=new SceneNode[1];
		results[0]=textureMaterial;
		return results;
	}

	public LightSource[] convertLights(Node node) {
		return null;
	}

}
