/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on May 17, 2006
 */
package eu.moonlight3d.ml3d.rendering.sunflow;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.framework.helper.Property;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.Slot;
import eu.moonlight3d.ml3d.backend.threedim.sg.SceneGraph;

public class CreateConstantMaterial extends Node {
    private Property name;
    private Property ownerName;
    private Property colour;

    public CreateConstantMaterial()
    {
        createSlot("input",Slot.Type.Input);
        createSlot("output",Slot.Type.Output);
        name=new Property(this);
        name.setName("name");
        name.setType(Property.Type.String);
        try {
            name.setValue("ConstantMaterial");
        } catch (Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();
        }
        ownerName=new Property(this);
        ownerName.setName("ownerName");
        ownerName.setType(Property.Type.String);
        try {
            ownerName.setValue("Mesh");
        } catch (Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();
        }
        colour=new Property(this);
        colour.setName("colour");
        colour.setType(Property.Type.Colour);
        try {
            colour.setValue(new Colour());
        } catch(Exception e) {
            // This exception shouldn't occur at all in this limited case
            e.printStackTrace();            
        }
    }
    
    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.backend.og.Node#update()
     */
    @Override
    public void update() throws Exception
    {
        SceneGraph graph;
        eu.moonlight3d.ml3d.backend.threedim.sg.Node owner;
        ConstantMaterial constantMaterial;
        
        graph=getSlot("input").getGraph();
        owner=graph.getNodeByName(ownerName.getStringValue());

        constantMaterial=(ConstantMaterial) graph.createNode("ConstantMaterial",name.getStringValue());
        
        constantMaterial.setColour(colour.getColourValue());

        graph.addNode(constantMaterial);
        graph.addChild(owner, constantMaterial);
      
        getSlot("output").setGraph(graph);
    }

	@Override
	public void removeDependencies() {
	}
}
