/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on May 16, 2006
 */
package eu.moonlight3d.ml3d.rendering.sunflow;


import org.w3c.dom.Document;
import org.w3c.dom.Element;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.ml3d.backend.threedim.sg.MaterialNode;

public class GlassMaterial extends MaterialNode {
	private Colour colour;
	private double eta;
	
	public GlassMaterial() {
		colour=new Colour();
		colour.red=1.0;
		colour.green=0.0;
		colour.blue=1.0;
		colour.alpha=1.0;
		eta=1.0;
	}
	
	public void setColour(Colour colour) {
		this.colour=colour.clone();
	}

	public Colour getColour() {
		return colour.clone();
	}
	
	public void setEta(double eta) {
		this.eta=eta;
	}
	
	public double getEta() {
		return eta;
	}
	
	@Override
	protected void loadXMLData(Element dataElement) {
		Element colourElement=(Element) dataElement.getElementsByTagName("colour").item(0);
		colour.red=Double.parseDouble(colourElement.getAttribute("r"));
		colour.green=Double.parseDouble(colourElement.getAttribute("g"));
		colour.blue=Double.parseDouble(colourElement.getAttribute("b"));
		colour.alpha=Double.parseDouble(colourElement.getAttribute("a"));
		Element etaElement=(Element) dataElement.getElementsByTagName("eta").item(0);
		eta=Double.parseDouble(etaElement.getAttribute("value"));
	}

	@Override
	protected void saveXMLData(Document document, Element dataElement) {
		Element colourElement=document.createElement("colour");
		colourElement.setAttribute("r",Double.toString(colour.red));
		colourElement.setAttribute("g",Double.toString(colour.green));
		colourElement.setAttribute("b",Double.toString(colour.blue));
		colourElement.setAttribute("a",Double.toString(colour.alpha));
		dataElement.appendChild(colourElement);
		Element etaElement=document.createElement("eta");
		etaElement.setAttribute("value",Double.toString(eta));
		dataElement.appendChild(etaElement);
	}


	@Override
	public String getType() {
		return "GlassMaterial";
	}

	public boolean isValidAppendixName(String appendix) {
		return false;
	}

	public Object getFromAppendix(String appendix) {
		return null;
	}

}
