/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on May 16, 2006
 */
package eu.moonlight3d.ml3d.rendering.sunflow;


import org.w3c.dom.Document;
import org.w3c.dom.Element;

import eu.moonlight3d.colour.Colour;
import eu.moonlight3d.ml3d.backend.threedim.sg.MaterialNode;

public class MirrorMaterial extends MaterialNode {
	private Colour reflectedColour;
	
	public MirrorMaterial() {
		reflectedColour=new Colour();
		reflectedColour.red=1.0;
		reflectedColour.green=0.0;
		reflectedColour.blue=1.0;
		reflectedColour.alpha=1.0;
	}
	
	public void setReflectedColour(Colour colour) {
		this.reflectedColour=colour.clone();
	}

	public Colour getReflectedColour() {
		return reflectedColour.clone();
	}
	
	@Override
	protected void loadXMLData(Element dataElement) {
		Element colourElement=(Element) dataElement.getElementsByTagName("reflectedcolour").item(0);
		reflectedColour.red=Double.parseDouble(colourElement.getAttribute("r"));
		reflectedColour.green=Double.parseDouble(colourElement.getAttribute("g"));
		reflectedColour.blue=Double.parseDouble(colourElement.getAttribute("b"));
		reflectedColour.alpha=Double.parseDouble(colourElement.getAttribute("a"));
	}

	@Override
	protected void saveXMLData(Document document, Element dataElement) {
		Element colourElement=document.createElement("reflectedcolour");
		colourElement.setAttribute("r",Double.toString(reflectedColour.red));
		colourElement.setAttribute("g",Double.toString(reflectedColour.green));
		colourElement.setAttribute("b",Double.toString(reflectedColour.blue));
		colourElement.setAttribute("a",Double.toString(reflectedColour.alpha));
		dataElement.appendChild(colourElement);
	}

	@Override
	public String getType() {
		return "MirrorMaterial";
	}

	public boolean isValidAppendixName(String appendix) {
		return false;
	}

	public Object getFromAppendix(String appendix) {
		return null;
	}

}
