/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 7, 2005
 */
package eu.moonlight3d.ml3d.scripting.python;

import java.util.ArrayList;

import eu.moonlight3d.framework.helper.DefaultFactory;

/**
 * This class provides the plugin interface for the python plugin
 *  
 * @author gregor
 */
public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {

    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.core.plugins.Plugin#getName()
     */
    public String getName()
    {
        return "eu.moonlight3d.ml3d.scripting.python.Plugin";
    }

    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.core.plugins.Plugin#getDependencies()
     */
    public ArrayList<String> getDependencies()
    {
        ArrayList<String> dependencyList = new ArrayList<String>();
        return dependencyList;
    }

    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.core.plugins.Plugin#load()
     */
    public void load() throws Exception
    {
        eu.moonlight3d.framework.scripts.Manager manager=eu.moonlight3d.framework.State.getInstance().getScriptManager();
        
        manager.registerLanguage(new Language());
        
//        Properties properties=new Properties();
//        properties.setProperty("python.packages.path","plugins/");
//        PythonInterpreter.initialize(null,properties,null);
        System.setProperty("python.cachedir",eu.moonlight3d.framework.State.getInstance().getPreferencesManager().getUserPreferencesPath());
        eu.moonlight3d.framework.State.getInstance().getUIManager().registerSyntaxHighlighterFactory(new DefaultFactory("Python",SyntaxHighlighter.class));
    }

    /* (non-Javadoc)
     * @see eu.moonlight3d.ml3d.core.plugins.Plugin#unload()
     */
    public void unload() throws Exception
    {
        eu.moonlight3d.framework.scripts.Manager manager=eu.moonlight3d.framework.State.getInstance().getScriptManager();
        
        manager.unregisterLanguage("Python");        

        eu.moonlight3d.framework.State.getInstance().getUIManager().unregisterSyntaxHighlighterFactory("Python");
    }
}
