/*
 * Moonlight|3D Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Feb 14, 2007
 */
package eu.moonlight3d.ml3d.test;

import eu.moonlight3d.framework.helper.StringTools;

public class StringToolsPerformance {
	static public void main(String args[]) {
		String[] testStrings=new String[1000000];
//		String[] testStrings=new String[10];
		for(int i=0;i<testStrings.length;i++) {
			String testString=Integer.toString(i);
			for(int j=1;j<10;j++) {
				testString+="/"+Integer.toString(i+j);
			}
			testStrings[i]=testString;
		}
		
		long startTime, endTime;

		for (int retries = 0; retries < 10; retries++) {
			System.out.println("Test " + retries);
			System.out.println("testing String.split()");
			startTime = System.currentTimeMillis();
			for (int i = 0; i < testStrings.length; i++) {
				String[] result = testStrings[i].split("/");
			}
			endTime = System.currentTimeMillis();
			System.out.println("duration: " + (endTime - startTime) + "ms");

			System.out.println("testing StringTools.split(String, char)");
			startTime = System.currentTimeMillis();
			for (int i = 0; i < testStrings.length; i++) {
				String[] result = StringTools.split(testStrings[i], '/');
			}
			endTime = System.currentTimeMillis();
			System.out.println("duration: " + (endTime - startTime) + "ms");

			System.out.println("testing StringTools.split(String, String)");
			startTime = System.currentTimeMillis();
			for (int i = 0; i < testStrings.length; i++) {
				String[] result = StringTools.split(testStrings[i], "/");
			}
			endTime = System.currentTimeMillis();
			System.out.println("duration: " + (endTime - startTime) + "ms");
		}
	}
}
