/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Oct 3, 2006
 */
package eu.moonlight3d.ml3d.ui.mainwindow.modes;

import eu.moonlight3d.framework.helper.NamedObject;

public abstract class Mode implements NamedObject {
	private String name;
	private String ogNodeName;
	private boolean active;
	
	public Mode(String name) {
		this.name=name;
	}
	
	public String getName() {
		return name;
	}
	
	public void setOGNodeName(String name) {
		this.ogNodeName=name;
	}
	
	public String getOGNodeName() {
		return ogNodeName;
	}
	
	public abstract void activated();
	
	public abstract void deactivated();
	
	final public void activate() {
		if(active) {
			return;
		}
		active=true;
		activated();
	}
	
	final public void deactivate() {
		if(!active) {
			return;
		}
		active=false;
		deactivated();
	}
	
	final public boolean isActive() {
		return active;
	}
}
