/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Dec 5, 2008
 */

package eu.moonlight3d.ml3d.ui.mainwindow.ogeditor;

import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import com.trolltech.qt.core.QPointF;

import eu.moonlight3d.graph.GraphModel;
import eu.moonlight3d.graph.Node;
import eu.moonlight3d.ml3d.backend.threedim.document.Document;

public class DocumentContribution implements eu.moonlight3d.common.document.extensible.DocumentContribution {

	public void close() {
		// nothing to do here
	}

	public String getName() {
		return "eu.moonlight3d.ml3d.ui.mainwindow.ogeditor.DocumentContribution";
	}

	public boolean hasUnsavedChanges() {
		// FIXME never claim unsaved changes - this is not always true
		return false;
	}

	public boolean retainAlways() {
		return true;
	}

	public void update() {
		// nothing to do here
	}

	public void write(org.w3c.dom.Document document, Element contributionRoot) throws Exception {
		contributionRoot.setAttribute("fileformatversion", "1");
		List<Node> nodes = ModelGenerator.getInstance().getGraphModel().getNodes();
		
		for(Node node : nodes) {
			QPointF position=node.getPosition();
			Element nodePosition=document.createElement("nodeposition");
			nodePosition.setAttribute("name", node.getName());
			nodePosition.setAttribute("x", Double.toString(position.x()));
			nodePosition.setAttribute("y", Double.toString(position.y()));
			contributionRoot.appendChild(nodePosition);
		}
	}

	public void read(Document document, Element contributionRoot) {
		GraphModel model=ModelGenerator.getInstance().getGraphModel();
		
		// HACK: force update of graph model here so that nodes are in model
		ModelGenerator.getInstance().updateGraph(document);
		
		NodeList list=contributionRoot.getElementsByTagName("nodeposition");
		for(int i=0;i<list.getLength();i++) {
			Element nodePosition=(Element) list.item(i);
			
			String nodeName=nodePosition.getAttribute("name");
			Node node=model.getNode(nodeName);
			// the mentioned node may not exist because the data might have gone out of sync with the OG contents:
			if(node!=null) { 
				double x=Double.parseDouble(nodePosition.getAttribute("x"));
				double y=Double.parseDouble(nodePosition.getAttribute("y"));
				node.setPosition(x,y);
			}
		}
	}
}
