/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Apr 4, 2006
 */
package eu.moonlight3d.ml3d.ui.mainwindow.ogeditor;

import eu.moonlight3d.ml3d.backend.threedim.og.Link;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.OperatorGraphListener;

public class OGListener implements OperatorGraphListener {
	public OGListener() {
	}

	public void nodeInserted(Node node) {
		// regenerate whole graph layout
		ModelGenerator generator=ModelGenerator.getInstance();
//		generator.updateGraph();
		generator.addNode(node);
	}

	public void nodeRemoved(Node node) {
		// regenerate whole graph layout
		ModelGenerator generator=ModelGenerator.getInstance();
//		generator.updateGraph();
		generator.removeNode(node);
	}

	public void nodeUpdated(Node node) {
		ModelGenerator generator=ModelGenerator.getInstance();
		generator.markUpdateOK(node);
	}

	public void nodeUpdateFailed(Node node, Exception exception) {
		// TODO Auto-generated method stub
		ModelGenerator generator=ModelGenerator.getInstance();
		generator.markUpdateFailure(node,exception);
	}

	public void graphUpdated() {
	}

	public void graphCleared() {
		// regenerate whole graph layout
		ModelGenerator generator=ModelGenerator.getInstance();
		generator.updateGraph();
	}

	public void linkInserted(Link link) {
		// regenerate whole graph layout
		ModelGenerator generator=ModelGenerator.getInstance();
//		generator.updateGraph();
		generator.addLink(link);
	}

	public void linkRemoved(Link link) {
		// regenerate whole graph layout
		ModelGenerator generator=ModelGenerator.getInstance();
//		generator.updateGraph();
		generator.removeLink(link);
	}
}
