/*
 * Moonlight|3D
 * Copyright (C) 2008 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Apr 4, 2008
 */

package eu.moonlight3d.ml3d.ui.mainwindow.propertyeditor;

import java.util.ArrayList;

import eu.moonlight3d.ml3d.backend.threedim.anim.AnimationTrack;

public class AnimationListener implements eu.moonlight3d.ml3d.backend.threedim.anim.AnimationListener {

	private void handleAnimationUpdate(double newTime) {
    	ArrayList<PropertyEditorView> propertyEditors=PropertyEditorView.getPropertyEditors();
        for(int i=0;i<propertyEditors.size();i++) {
            propertyEditors.get(i).handleAnimationUpdate(newTime);
        }	
	}
	
	private void handleAnimationUpdate() {
    	ArrayList<PropertyEditorView> propertyEditors=PropertyEditorView.getPropertyEditors();
        for(int i=0;i<propertyEditors.size();i++) {
            propertyEditors.get(i).handleAnimationUpdate();
        }	
	}
	
	public void currentTimeUpdated(double oldTime, double newTime) {
		handleAnimationUpdate(newTime);
	}

	public void defaultsSet() {
		handleAnimationUpdate();
	}

	public void endTimeUpdated(double oldEndTime, double newEndTime) {
		handleAnimationUpdate();
	}

	public void framesPerSecondUpdated(double oldFramesPerSecond, double newFramesPerSecond) {
		handleAnimationUpdate();
	}

	public void startTimeUpdated(double oldStartTime, double newStartTime) {
		handleAnimationUpdate();
	}

	public void trackAdded(AnimationTrack track) {
		handleAnimationUpdate();
	}

	public void trackRemoved(AnimationTrack track) {
		handleAnimationUpdate();
	}

}
