/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jun 14, 2005
 */
package eu.moonlight3d.ml3d.ui.mainwindow.propertyeditor;

import java.util.ArrayList;

import eu.moonlight3d.framework.helper.Observed;
import eu.moonlight3d.framework.helper.Observer;


public class OperatorGraphObserver implements Observer {
    private boolean blockUpdates;
    
    public OperatorGraphObserver()
    {
        super();
        blockUpdates=false;
    }
    
    public void disableUpdates() {
   		blockUpdates=true;
    }
    
    public void enableUpdates() {
   		blockUpdates=false;
    }
    
    public void notify(Observed observed)
    {
   		if (blockUpdates) {
			return;
		}

		disableUpdates();
		ArrayList<PropertyEditorView> propertyEditors = PropertyEditorView.getPropertyEditors();
		for (int i = 0; i < propertyEditors.size(); i++) {
			propertyEditors.get(i).handleValueUpdate();
		}
		enableUpdates();
    }

}
