/*
 * Moonlight|3D Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 26, 2007
 */
package eu.moonlight3d.ml3d.ui.mainwindow.toolchest;

import eu.moonlight3d.framework.ui.Action;

public class ToolAction extends Action {
	private String toolName;
	
	public ToolAction(String name, String displayName, String icon, String defaultMenuLocation, String category, String toolName) {
		super(name,displayName,null);
		if(icon!=null) {
			setIcon(icon);
		}
		this.toolName=toolName;
        triggered.connect(this,"run()");
	}
	
	public ToolAction(String name, String displayName, String icon, String defaultMenuLocation, String category, String toolName, String shortcut) {
		super(name,displayName,null);
		if(icon!=null) {
			setIcon(icon);
		}
		this.toolName=toolName;
		setShortcut(shortcut);
        triggered.connect(this,"run()");
	}
	
	@Override
	public void run() {
		// simply activate named tool
		ToolChestView.activateTool(toolName);
	}
}
