/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Nov 14, 2005
 */
package eu.moonlight3d.ml3d.ui.mainwindow.view;


import com.trolltech.qt.core.Qt;

public class DragViewEventHandler extends StandardViewEventHandler {
    private boolean altDown;
	private boolean dragging;
	
	public DragViewEventHandler() {
		altDown=false;
		dragging=false;
	}

    @Override
	public void keyPress(int key, Qt.KeyboardModifiers state) throws Exception {
        if(key==Qt.Key.Key_Escape.value()) { // terminate this mode on ESC key press
            ViewEventHandler.removeEventHandler();
        } else if(key==Qt.Key.Key_Alt.value()) {
            altDown=true;
            super.keyPress(key,state);
        }
    }
        
    @Override
	public void keyRelease(int key, Qt.KeyboardModifiers state) throws Exception {
   		if(key==Qt.Key.Key_Alt.value()) {
            altDown=false;
            super.keyRelease(key,state);
        }
    }

    @Override
    public void mouseButtonDown(Qt.MouseButton button) throws Exception {
        if(altDown==true) {
            super.mouseButtonDown(button);
        } else if(button==Qt.MouseButton.LeftButton) {
        		dragging=true;
            startDragging();
        }
    }
        
    protected void startDragging() throws Exception {
	}
    
    protected void stopDragging() throws Exception {
    }

	@Override
    public void mouseButtonUp(Qt.MouseButton button) throws Exception {
        super.mouseButtonUp(button);
        dragging=false;
        stopDragging();
    }

	protected void handleDrag(int oldX, int oldY, int newX, int newY) throws Exception {
	}

	@Override
    public void mouseMove(int oldX, int oldY, int newX, int newY) throws Exception {
        super.mouseMove(oldX,oldY,newX,newY);
        if(dragging) {
            handleDrag(oldX,oldY,newX,newY);
        }
    }

}
