/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Feb 23, 2006
 */
package eu.moonlight3d.ml3d.ui.mainwindow.view;

import javax.media.opengl.GL;

import eu.moonlight3d.framework.State;


public class GLHelper {
	public static void checkAndLogGLError(GL gl, String operation) {
		String message = operation + " failed: ";

		int errorValue = gl.glGetError();
		if (errorValue == GL.GL_NO_ERROR) {
			return;
		}

		if (errorValue == GL.GL_INVALID_ENUM) {
			message = message + "GL_INVALID_ENUM";
		}
		if (errorValue == GL.GL_INVALID_VALUE) {
			message = message + "GL_INVALID_VALUE";
		}
		if (errorValue == GL.GL_INVALID_OPERATION) {
			message = message + "GL_INVALID_OPERATION";
		}
		if (errorValue == GL.GL_STACK_OVERFLOW) {
			message = message + "GL_STACK_OVERFLOW";
		}
		if (errorValue == GL.GL_STACK_UNDERFLOW) {
			message = message + "GL_STACK_UNDERFLOW";
		}
		if (errorValue == GL.GL_OUT_OF_MEMORY) {
			message = message + "GL_OUT_OF_MEMORY";
		}
		if (errorValue == GL.GL_TABLE_TOO_LARGE) {
			message = message + "GL_TABLE_TOO_LARGE";
		}

		State.getInstance().logger().warning(message);
	}
}
