/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Feb 3, 2006
 */
package eu.moonlight3d.ml3d.ui.mainwindow.view;

import eu.moonlight3d.ml3d.backend.threedim.og.Link;
import eu.moonlight3d.ml3d.backend.threedim.og.Node;
import eu.moonlight3d.ml3d.backend.threedim.og.OperatorGraphListener;

public class OGListener implements OperatorGraphListener {

	public void nodeInserted(Node node) {
		if(node.isDrain()) {
			OpenGLConverter.getInstance().convertOGNodeOutput(node);
		}
	}

	public void nodeRemoved(Node node) {
		if(node.isDrain()) {
			OpenGLConverter.getInstance().removeOGNodeOutput(node);
		}
	}

	public void nodeUpdated(Node node) {
		if(node.isDrain()) {
			OpenGLConverter.getInstance().removeOGNodeOutput(node);
			OpenGLConverter.getInstance().convertOGNodeOutput(node);
		}
	}

	public void nodeUpdateFailed(Node node, Exception exception) {
		// TODO handle evaluation failure in a visual way
	}

	public void graphUpdated() {
//		try {
//			OpenGLConverter.getInstance().run();
//		} catch (Exception e) {
//			// this should not happen
//			e.printStackTrace();
//		}
		OpenGLConverter.getInstance().redrawViews();
	}

	public void linkInserted(Link link) {
		Node sourceNode=link.getInput().getNode();
		Node targetNode=link.getOutput().getNode();
		
		if(targetNode.isDrain()) {
			OpenGLConverter.getInstance().removeOGNodeOutput(sourceNode);
			OpenGLConverter.getInstance().convertOGNodeOutput(targetNode);
		}
	}

	public void linkRemoved(Link link) {
		Node sourceNode=link.getInput().getNode();
		Node targetNode=link.getOutput().getNode();
		if(sourceNode.isDrain()) {
			OpenGLConverter.getInstance().removeOGNodeOutput(targetNode);
			OpenGLConverter.getInstance().convertOGNodeOutput(sourceNode);
		}
	}

	public void graphCleared() {
		OpenGLConverter.getInstance().clearScene();
		OpenGLConverter.getInstance().redrawViews();
	}

}
