/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Nov 4, 2005
 */
package eu.moonlight3d.ml3d.ui.mainwindow.view;

import java.util.ArrayList;

import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.ui.Action;

public class ResetViewportAction extends Action {
	private Viewport.StandardPerspective perspective;
	
	public ResetViewportAction(QWidget parent, String name, String label, String shortcut, Viewport.StandardPerspective perspective) {
		super(name,label,parent);
		triggered.connect(this,"run()");
		setShortcut(shortcut);
		this.perspective=perspective;
	}

	@Override
	public void run() throws Exception {
        ArrayList<Viewport> viewports = OpenGLConverter.getInstance().getRegisteredViews();
        
        // set modelview matrix on viewports
        for(int i=0;i<viewports.size();i++) {
            Viewport viewport=viewports.get(i);
            if(viewport.hasKeyboardFocus()) {
            	viewport.setStandardPerspective(perspective);
            }
        }
        OpenGLConverter.getInstance().redrawViews();
	}
}
