/*
 * Moonlight|3D
 * Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Oct 11, 2007
 */

package eu.moonlight3d.ml3d.ui.mainwindow.view;

import java.util.ArrayList;
import java.util.List;

import javax.media.opengl.GL;

public class SceneNode {
	private String ogNodeName;
	private ArrayList<SceneNode> children=new ArrayList<SceneNode>();
	private boolean isToplevel=true;

	public String getOGNodeName() {
		return ogNodeName;
	}

	public void setOGNodeName(String ogNodeName) {
		this.ogNodeName = ogNodeName;
	}
	
	public void addChild(SceneNode child) {
		children.add(child);
	}
	
	public void removeChild(SceneNode child) {
		children.remove(child);
	}
	
	public List<SceneNode> getChildren() {
		return children;
	}

	public boolean isToplevel() {
		return isToplevel;
	}

	public void setToplevel(boolean isToplevel) {
		this.isToplevel = isToplevel;
	}
	
	public void dispose(GL gl) {
		
	}	
}
