/*
 * Moonlight|3D Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Mar 18, 2007
 */
package eu.moonlight3d.ml3d.ui.resourcelist;


import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.ui.Action;
import eu.moonlight3d.framework.ui.ApplicationWindow;
import eu.moonlight3d.framework.ui.ExceptionDialog;
import eu.moonlight3d.framework.ui.UIManager;

public class OpenResourceListAction extends Action {
	public OpenResourceListAction(QWidget parent) {
		super("OpenResourceListAction","Open Resource List",parent);
        triggered.connect(this,"run()");
	}

	@Override
	public void run() {
		UIManager uiManager=State.getInstance().getUIManager();
        try {
			new ApplicationWindow(uiManager.getLayout("resourcelist")).show();
		} catch (Exception e) {
			ExceptionDialog.run(e);
		}
	}
}
