/*
 * Moonlight|3D Copyright (C) 2005 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Jan 13, 2005
 */
package eu.moonlight3d.ml3d.ui.testplugin;

import java.util.ArrayList;

import eu.moonlight3d.framework.State;
import eu.moonlight3d.framework.ui.MenuNode;
import eu.moonlight3d.framework.ui.UIManager;


/**
 * This is the plugin class for the UI test plugin
 * 
 * @author gregor
 */
public class Plugin implements eu.moonlight3d.framework.plugins.Plugin {
//	private TestMode testMode;
//	private AnotherTestMode anotherTestMode;
//	private TestTool testTool;
//	private AnotherTestTool anotherTestTool;

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#getName()
	 */
	public String getName() {
		return "eu.moonlight3d.ml3d.ui.testplugin.Plugin";
	}

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#getDependencies()
	 */
	public ArrayList<String> getDependencies() {
		ArrayList<String> dependencyList=new ArrayList<String>();
		
		dependencyList.add("eu.moonlight3d.ml3d.ui.mainwindow.Plugin");
		
		return dependencyList;
	}

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#load()
	 */
	public void load() throws Exception {
		UIManager uiManager=State.getInstance().getUIManager();
		uiManager.registerAction(new TestTaskAction(null));
		
		MenuNode contribution=new MenuNode(MenuNode.Type.Contribution,"Test","menubar");
		MenuNode testMenu=new MenuNode(MenuNode.Type.Menu,"Test","");
		MenuNode testExtensionPoint=new MenuNode(MenuNode.Type.ExtensionPoint,"testExtensionPoint","");
		testMenu.add(new MenuNode(MenuNode.Type.Entry,"Test task","TestTaskAction"));
		testMenu.add(testExtensionPoint);
		contribution.add(testMenu);
		State.getInstance().getUIManager().getLayout("mainwindow").addMenuContribution(contribution);
		
//		testMode=new TestMode();
//		eu.moonlight3d.ml3d.ui.mainwindow.modes.ModeManager.getInstance().addMode(testMode);
//		anotherTestMode=new AnotherTestMode();
//		eu.moonlight3d.ml3d.ui.mainwindow.modes.ModeManager.getInstance().addMode(anotherTestMode);
//		testTool=new TestTool(testMode);
//		anotherTestTool=new AnotherTestTool(anotherTestMode);
//		eu.moonlight3d.ml3d.ui.mainwindow.toolchest.ToolChestView.addTool(testTool);
//		eu.moonlight3d.ml3d.ui.mainwindow.toolchest.ToolChestView.addTool(anotherTestTool);
	}

	/* (non-Javadoc)
	 * @see eu.moonlight3d.ml3d.core.plugins.Plugin#unload()
	 */
	public void unload() throws Exception {
		UIManager uiManager=State.getInstance().getUIManager();
		uiManager.unregisterAction("TestTaskAction");

//		eu.moonlight3d.ml3d.ui.mainwindow.toolchest.ToolChestView.removeTool(testTool);
//		eu.moonlight3d.ml3d.ui.mainwindow.toolchest.ToolChestView.removeTool(anotherTestTool);
//		eu.moonlight3d.ml3d.ui.mainwindow.modes.ModeManager.getInstance().removeMode(testMode);
//		eu.moonlight3d.ml3d.ui.mainwindow.modes.ModeManager.getInstance().removeMode(anotherTestMode);
	}

}
