/*
 * Moonlight|3D Copyright (C) 2006 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Created on Dec 7, 2006
 */
package eu.moonlight3d.ml3d.ui.testplugin;


import com.trolltech.qt.gui.QLabel;
import com.trolltech.qt.gui.QVBoxLayout;
import com.trolltech.qt.gui.QWidget;

import eu.moonlight3d.ml3d.ui.mainwindow.modes.Mode;
import eu.moonlight3d.ml3d.ui.mainwindow.toolchest.Tool;

public class TestTool extends Tool {

	public TestTool(Mode mode) {
		super(mode);
		setName("TestTool");
		setDisplayName("Test");
		setCategory("Test/Just Testing");
	}
	
	@Override
	public void activated() {
		eu.moonlight3d.framework.State.getInstance().logger().info("TestTool activated");
	}
	
	@Override
	public void deactivated() {
		eu.moonlight3d.framework.State.getInstance().logger().info("TestTool deactivated");
	}

	@Override
	public QWidget getOptionEditor(QWidget parent) {
		QWidget widget=new QWidget(parent);
		QLabel label=new QLabel(widget);
		label.setText("dummy label");
		QVBoxLayout layout=new QVBoxLayout();
		layout.addWidget(label);
		widget.setLayout(layout);
		return widget;
	}

	@Override
	public boolean hasOptionEditor() {
		return true;
	}
}
