/*
 * Moonlight|3D
 * Copyright (C) 2007 The Moonlight|3D team
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Created on Aug 12, 2007
 */

package eu.moonlight3d.graph.test;

import com.trolltech.qt.gui.QApplication;
import com.trolltech.qt.gui.QMainWindow;

import eu.moonlight3d.graph.GraphModel;
import eu.moonlight3d.graph.GraphView;
import eu.moonlight3d.graph.layout.SimpleLayouter;

/**
 * Main class for the test application
 *
 * @author gregor
 */
public class Main {

	/**
	 * Test application main
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		QApplication app=new QApplication(args);
		
		QMainWindow mainWindow=new QMainWindow();

		GraphModel graphModel=new GraphModel();
		graphModel.setLayouter(new SimpleLayouter());
		GraphView graphView=new GraphView(mainWindow);
		graphView.setGraphModel(graphModel);
//		GraphModelGenerator.generateLinearGraph(graphModel, 100, 15);
		GraphModelGenerator.generateBranchingGraph(graphModel, 10);
		graphModel.recalculateLayout();
		
		mainWindow.setCentralWidget(graphView);
		mainWindow.setWindowTitle("MLGraph test");
		
		mainWindow.show();
		
		QApplication.exec();
	}

}
